component {

    property name="swaggerService"             inject="swaggerService";
    property name="systemConfigurationService" inject="systemConfigurationService";
    property name="environment"                inject="coldbox:setting:environment";

    function index( event, rc, prc ) {

        if ( !isFeatureEnabled( "restSwagger" ) ) {
            event.notFound();
        }

        event.renderData( type="json", data=swaggerService.getSpecification() );
    }

    function ui( event, rc, prc ) {

        if ( !isFeatureEnabled( "restSwagger" ) || !_isSwaggerUiEnabled() ) {
            event.notFound();
        }

        // do this only in dev mode and if the preside-ext-rest-security extension is available
        if ( isFeatureEnabled( "restSecurity") && environment == "local" ) {
            prc.apitoken = systemConfigurationService.getSetting(
                  category = "rest-security"
                , setting  = "api_key"
                , default  = ""
            );
        }

        return renderView( view="/swagger/ui", args=arguments );
    }

    private boolean function _isSwaggerUiEnabled() {
        var isSwaggerUiEnabled = systemConfigurationService.getSetting(
              category = "rest-swagger"
            , setting  = "enableSwaggerUi"
            , default  = true
        );

        return isBoolean( isSwaggerUiEnabled ) && isSwaggerUiEnabled;
    }
}